dnl -*- Autoconf -*-
dnl
dnl


AC_DEFUN([_AC_CHECK_PROG_EXISTS],
  [
   AC_CACHE_CHECK([wether JVM [$1] exists], [ac_cv_vm_exists],
                  [ac_cv_vm_exists=no
                   test -f "$1" && ac_cv_vm_exists=yes])
  ]
)


dnl
dnl AC_CHECK_PROG_LIST(PROG-LIST, CLASSPATH-FLAG, PROPERTY-FLAG, JAR-FLAG)
dnl ------------------------------------------------------------------
dnl
AC_DEFUN([_AC_CHECK_PROG_LIST], 
 [
   AC_REQUIRE([AC_EXEEXT])dnl
   # Check wether we were supplied a PROG variable
   if test "x$[]PROG" != "x"; then
     # Try to find a PROG that matches in PROG-LIST
     for i in $1
     do
       if echo "$[]PROG" | grep "$i$EXEEXT\$" >/dev/null 2>&1; then
            _AC_CHECK_PROG_EXISTS($[]PROG, $2, $3, $4)
	    if test $ac_cv_vm_exists = yes; then
	      AC_SUBST([PROG], [$i$EXEEXT])
	    else
	      AC_MSG_ERROR([$1 cannot be found, aborting])
	    fi
            break
       fi
     done
   fi
   if test "x$[]PROG" = "x" || test "x$[]PROG" = "xnot found"; then
     AC_MSG_CHECKING([for MESSAGE named [$1]])
     AC_CACHE_VAL(_AC_MAKE_CACHE_VAR_FROM([PROG], [$1]), [dnl
       _AC_MAKE_CACHE_VAR_FROM([PROG], [$1])="no"
       for i in $1
       do
         if test "x$ac_cv_java_home" = "x"; then
	   ext_path="$PATH"
         else
           ext_path="$ac_cv_java_home/bin:$ac_cv_java_home"
         fi
	 # Stolen from shtool.m4
	 ac_paths="`echo $ext_path |\
           sed -e 's%/*:%:%g' -e 's%/*$%%' \
               -e 's/^:/.:/' -e 's/::/:.:/g' -e 's/:$/:./' \
               -e 's/:/ /g'`"
	 for ac_path in $ac_paths
         do
	   if test -f "$ac_path/$i$EXEEXT"; then 
             _AC_MAKE_CACHE_VAR_FROM([PROG], [$1])="$ac_path/$i$EXEEXT"
	     break 2
	   fi
         done
     done])
     AC_MSG_RESULT($[]_AC_MAKE_CACHE_VAR_FROM([PROG], [$1]))
     if test "x$[]_AC_MAKE_CACHE_VAR_FROM([PROG], [$1])" != "xno"; then
        AC_SUBST([PROG], [$[]_AC_MAKE_CACHE_VAR_FROM([PROG], [$1])])
     fi
   fi
 ]
)


AC_DEFUN([_AC_PROG_CHOOSE_LIST],
  [
    m4_if($#, 0, ,
          $#, 1, [_AC_CHECK_PROG_LIST($1)],
         [_AC_CHECK_PROG_LIST($1) _AC_PROG_CHOOSE_LIST(m4_shift($@))])
  ]
)


dnl
dnl AC_PROG_CHOOSE(VARIABLE, FLAGS-LIST, PROG-LIST, opt MESSAGE, opt TEST-LIST)
dnl --------------------------------------------------------------------------
dnl [_AC_PROG_CHOOSE_LIST($1, $2, $3, $4, $5) [AC_PROG_CHOOSE($1, m4_shift($2), $3, $4, $5)]])
dnl Checks for various programs in `PROG-LIST', and sets `VARIABLE' and
dnl `FLAGS' if all tests in `TEST-LIST' succeed.
AC_DEFUN([AC_PROG_CHOOSE],
  [
    m4_pushdef([PROG], [$1])
    m4_pushdef([FLAGLIST], [$2])
    m4_pushdef([MESSAGE], [$4])
    m4_pushdef([TESTLIST], [$5])
    _AC_PROG_CHOOSE_LIST($3)
    m4_popdef([TESTLIST])
    m4_popdef([MESSAGE])
    m4_popdef([FLAGLIST])
    m4_popdef([PROG])
  ]
)