dnl -*- Autoconf -*-
dnl
dnl 


AC_DEFUN([_AC_ARG_VAR_JAVA],
  [
    AC_ARG_VAR([JAVA], [Java virtual machine command])dnl
    AC_ARG_VAR([JAVA_HOME], [Java Development Kit toplevel directory])dnl
    AC_ARG_VAR([CLASSPATH], 
               [classpath flags, e.g. -cp<classes dir>:<jar file> if you have
                classes in a nonstandard directory <classes dir>
                or nonstandard jar file <jar file>])dnl
    if test "x$JAVA_HOME" != "x"; then
      ac_cv_java_home="$JAVA_HOME"
    fi
  ]
)

AC_DEFUN([_AC_ARG_WITH_JAVAHOME],
  [
    AC_ARG_WITH([java-home],
		AC_HELP_STRING([--with-jdk-home=DIR], 
                               [Java Development Kit toplevel directory is DIR]),
                [ac_cv_java_home="$withval"])
  ]
)


dnl should be replaced with _AC_CHECK_VM_WORKS
AC_DEFUN([_AC_CHECK_VM_EXISTS],
  [
   AC_CACHE_CHECK([wether JVM [$1] exists], [ac_cv_vm_exists],
                  [ac_cv_vm_exists=no
                   test -f "$1" && ac_cv_vm_exists=yes])
  ]
)

AC_DEFUN([_AC_MAKE_CACHE_VAR_FROM], [ac_cv_pt_[$1]_[]m4_translit([$2], [ .-], [___])])

dnl
dnl AC_CHECK_VM_LIST(VM-LIST, CLASSPATH-FLAG, PROPERTY-FLAG, JAR-FLAG)
dnl ------------------------------------------------------------------
dnl
AC_DEFUN([_AC_CHECK_VM_LIST], 
 [
   AC_REQUIRE([AC_EXEEXT])dnl
   AC_REQUIRE([_AC_ARG_WITH_JAVAHOME])dnl
   AC_REQUIRE([_AC_ARG_VAR_JAVA])dnl
   # Check wether we were supplied a JAVA variable
   if test "x$JAVA" != "x"; then
     # Try to find a VM that matches in VM-LIST
     for i in $1
     do
       if echo "$JAVA" | grep "$i$EXEEXT\$" >/dev/null 2>&1; then
            _AC_CHECK_VM_EXISTS($JAVA, $2, $3, $4)
	    if test $ac_cv_vm_exists = yes; then
	      AC_SUBST([JAVA], [$i$EXEEXT])
	    else
	      AC_MSG_ERROR([$1 cannot be found, aborting])
	    fi
            break
       fi
     done
   fi
   if test "x$JAVA" = "x" || test "x$JAVA" = "xnot found"; then
     AC_MSG_CHECKING([for Java Virtual Machine(s) named [$1]])
     AC_CACHE_VAL(_AC_MAKE_CACHE_VAR_FROM([java], [$1]), [dnl
       _AC_MAKE_CACHE_VAR_FROM([java], [$1])="no"
       for i in $1
       do
         if test "x$ac_cv_java_home" = "x"; then
	   ext_path="$PATH"
         else
           ext_path="$ac_cv_java_home/bin:$ac_cv_java_home"
         fi
	 # Stolen from shtool.m4
	 ac_paths="`echo $ext_path |\
           sed -e 's%/*:%:%g' -e 's%/*$%%' \
               -e 's/^:/.:/' -e 's/::/:.:/g' -e 's/:$/:./' \
               -e 's/:/ /g'`"
	 for ac_path in $ac_paths
         do
	   if test -f "$ac_path/$i$EXEEXT"; then 
             _AC_MAKE_CACHE_VAR_FROM([java], [$1])="$ac_path/$i$EXEEXT"
	     break 2
	   fi
         done
     done])
     AC_MSG_RESULT($[]_AC_MAKE_CACHE_VAR_FROM([java], [$1]))
     if test "x$[]_AC_MAKE_CACHE_VAR_FROM([java], [$1])" != "xno"; then
        AC_SUBST([JAVA], [$[]_AC_MAKE_CACHE_VAR_FROM([java], [$1])])
     fi
   fi
 ]
)


AC_DEFUN([AC_PROG_JAVA],
 [
   m4_if($#, 0, , 
         $#, 1, [_AC_CHECK_VM_LIST($1)],
         [_AC_CHECK_VM_LIST($1) AC_PROG_JAVA(m4_shift($@))])
 ]
)