/*******************************************************************************
* Licensed Materials - Property of IBM
*
* "Restricted Materials of IBM"
*
* Copyright (c) 2009 IBM Corporation.
*
* Contributors: 
*     IBM Corporation - initial API and implementation
*******************************************************************************/
package atomicsets;

public class OrderedLock implements Comparable{

  private static int index = 0;

  public static synchronized int allocateIndex() {
    return ++index;
  }

  private int myIndex;

  public final synchronized int getIndex() {
	if (myIndex == 0)
		myIndex = allocateIndex();
    return myIndex;
  };

  public final Object checkCast(Object o) {
    if (this != ((Atomic)o).getLock())
      throw new ClassCastException("Atomic set aliasing not satisfied");
    return o;
  }

  public int compareTo(Object o){
    int thisIndex = getIndex();
    int thatIndex = ((OrderedLock)o).getIndex();
    return thisIndex > thatIndex ? -1 : (thisIndex < thatIndex ? 1 : 0);
  }

  public static void sort(OrderedLock[] locks){
    java.util.Arrays.sort(locks);
  }
}
