/*  Jcurzez - A free Java implementation of curses
 *  Copyright (C) 2001, 2006  Thomas G. Girard <thomas.g.girard@free.fr>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.nongnu.savannah.jcurzez;

/**
 * A foreground color.
 * There are several predefined foreground colors : <ul>
 * <li>{@link #BLACK}</li>
 * <li>{@link #RED}</li>
 * <li>{@link #YELLOW}</li>
 * <li>{@link #BLUE}</li>
 * <li>{@link #MAGENTA}</li>
 * <li>{@link #GREEN}</li>
 * <li>{@link #CYAN}</li>
 * <li>{@link #WHITE}</li>
 * </ul>
 *
 * @author Thomas Girard
 * @version 1.0.0
 */
public final class ForegroundColor extends Color {
    /**
     * Creates a foreground color with specified name.
     *
     * @param    name the color name.
     */
    private ForegroundColor(String name) {
	super(name);
    }

    /** The foreground color black. */
    public static final ForegroundColor BLACK = new ForegroundColor("black");

    /** The foreground color red. */
    public static final ForegroundColor RED = new ForegroundColor("red");

    /** The foreground color green. */
    public static final ForegroundColor GREEN = new ForegroundColor("green");

    /** The foreground color yellow. */
    public static final ForegroundColor YELLOW = new ForegroundColor("yellow");

    /** The foreground color blue. */
    public static final ForegroundColor BLUE = new ForegroundColor("blue");

    /** The foreground color magenta. */
    public static final ForegroundColor MAGENTA = new ForegroundColor("magenta");

    /** The foreground color cyan. */
    public static final ForegroundColor CYAN = new ForegroundColor("cyan");

    /** The foreground color white. */
    public static final ForegroundColor WHITE = new ForegroundColor("white");
}
