package org.nongnu.savannah.jcurzez.test;

import atomicsets.OrderedLock;
import org.nongnu.savannah.jcurzez.Area;
import org.nongnu.savannah.jcurzez.BackgroundColor;
import org.nongnu.savannah.jcurzez.ForegroundColor;
import org.nongnu.savannah.jcurzez.Rectangle;
import org.nongnu.savannah.jcurzez.Screen;

// Two threads write to different areas that mapped to the same shared buffer space.
// During test, each of the three lines should appear blank, all ones, or all twos.
// A line should never have a combination of ones and twos.  (An argument could be 
// made for refresh not being synchronous, but even then, we should ensure no mixed
// lines at the end.)

public class ThreadedOverlappedAreas {

	volatile static boolean stop = false;

	public static void main(String[] args) {
		final Screen s = Screen.getScreen();
	
		s.clear();
	
		
		Thread area1 = new Thread(){
			public void run(){
				// aj restructuring
				Area a = s.constructChildArea(new Rectangle(30,10,50,13, new OrderedLock()), false, false);
				//Area a = new Area(new Rectangle(30,10,50,13));
				a.getRectangle().getDrawingPen().setBackgroundColor(BackgroundColor.CYAN);
				a.stressConcurrency = true;
				//while (!stop) {
					a.setCursorXY(0, 0);
					a.printString("1111111111111111111\n");
					a.printString("1111111111111111111\n");
					a.printString("1111111111111111111\n");
					//a.refresh();
				//}
			}
		};
		
		Thread area2 = new Thread(){
			public void run(){
				// aj restructuring
				Area a = s.constructChildArea(new Rectangle(30,10,50,13, new OrderedLock()), false, false);
				//Area a = new Area(new Rectangle(30,10,50,13));
				a.getRectangle().getDrawingPen().setBackgroundColor(BackgroundColor.MAGENTA);
				//a.stressConcurrency = true;
				//while (!stop) {
					a.setCursorXY(0, 0);
					a.printString("2222222222222222222\n");
					a.printString("2222222222222222222\n");
					a.printString("2222222222222222222\n");
					//a.refresh();
				//}
			}
		};
		
		Thread refresher = new Thread(){
			public void run(){
				while (true){
					s.refresh();
					try{Thread.sleep(10);}catch(Exception e){}
				}
			}
		};
		refresher.setDaemon(true);
		refresher.start();
		
		
		area1.start();
		area2.start();
		//try{ Thread.sleep(20000); } catch (InterruptedException ie) {}
		stop = true;
		try{
			area1.join();
			area2.join();
		}catch(InterruptedException ie){	
		}
		
		try{ Thread.sleep(100); } catch (InterruptedException ie) {} //make sure a final refresh happens
						
	}

}
