dnl -*- Autoconf -*-

AC_DEFUN([_AC_ARG_VAR_JAVAC],
  [
    AC_ARG_VAR([JAVAC], [Java(TM) compiler command])
    AC_ARG_VAR([JAVACFLAGS], [Java(TM) compiler flags])
  ]
)

dnl
dnl @synopsis AC_CHECK_JC
dnl
dnl Sets JAVAC, JAVACCLASSPATHFLAG, JAVACSOURCEPATHFLAG, JAVACDEBUGFLAG,
dnl JAVACOUTPUTDIR
dnl according to $2, $3, $4.
dnl
dnl $1 Java compiler to check for.
dnl $2 JAVACCLASSPATHFLAG to set.
dnl $3 JAVACSOURCEPATHFLAG to set.
dnl $4 JAVACDEBUGFLAG to set.
dnl $5 JAVACOUTPUTDIR to set.
dnl
AC_DEFUN([AC_CHECK_JC],
  [
    AC_REQUIRE([AC_EXEEXT])dnl
    AC_CHECK_PROG(JAVAC, $1$EXEEXT, found, not found)dnl
    if test "x$JAVAC" = "xfound"; then
      AC_SUBST(JAVAC, $1$EXEEXT)dnl
      m4_ifval([$2], AC_SUBST(JAVACCLASSPATHFLAG, $2))dnl
      m4_ifval([$3], AC_SUBST(JAVACSOURCEPATHFLAG, $3))dnl
      m4_ifval([$4], AC_SUBST(JAVACDEBUGFLAG, $4))dnl
      m4_ifval([$5], AC_SUBST(JAVACOUTPUTDIR, $5))dnl
    fi
    AC_PROVIDE([$0])dnl
  ]
)
