/*  Jcurzez - A free Java implementation of curses
 *  Copyright (C) 2001, 2006  Thomas G. Girard <thomas.g.girard@free.fr>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.nongnu.savannah.jcurzez.test;

import org.nongnu.savannah.jcurzez.*;

/**
 * Tests the screen object.
 *
 * @author Thomas Girard
 * @version 1.0.0
 */
public class ScreenMain {
    /**
     * Runs the {@link jcurzez.test.Test} program using the <code>Screen</code>
     * object.
     */
    public static void main(String[] args) {
	Screen screen = Screen.getScreen();
	Pen pen = screen.getRectangle().getFillingPen();
	pen.setBackgroundColor(BackgroundColor.BLACK);
	pen.setForegroundColor(ForegroundColor.WHITE);

	pen = screen.getRectangle().getDrawingPen();
	pen.setBackgroundColor(BackgroundColor.BLUE);
	pen.setForegroundColor(ForegroundColor.RED);
	screen.beep();
	Test t = new Test(screen, 1500);
    }
}
