/*  Jcurzez - A free Java implementation of curses
 *  Copyright (C) 2001, 2006  Thomas G. Girard <thomas.g.girard@free.fr>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.nongnu.savannah.jcurzez;

/**
 * A background color.
 * There are several predefined background colors : <ul>
 * <li>{@link #BLACK}</li>
 * <li>{@link #RED}</li>
 * <li>{@link #YELLOW}</li>
 * <li>{@link #BLUE}</li>
 * <li>{@link #MAGENTA}</li>
 * <li>{@link #GREEN}</li>
 * <li>{@link #CYAN}</li>
 * <li>{@link #WHITE}</li>
 * </ul>
 *
 * @author Thomas Girard
 * @version 1.0.0
 */
public final class BackgroundColor extends Color {
    /**
     * Creates a background color with specified name.
     *
     * @param    name the color name.
     */
    private BackgroundColor(String name) {
	super(name);
    }

    /** The background color black. */
    public static final BackgroundColor BLACK = new BackgroundColor("black");

    /** The background color red. */
    public static final BackgroundColor RED = new BackgroundColor("red");

    /** The background color green. */
    public static final BackgroundColor GREEN = new BackgroundColor("green");

    /** The background color yellow. */
    public static final BackgroundColor YELLOW = new BackgroundColor("yellow");

    /** The background color blue. */
    public static final BackgroundColor BLUE = new BackgroundColor("blue");

    /** The background color magenta. */
    public static final BackgroundColor MAGENTA = new BackgroundColor("magenta");

    /** The background color cyan. */
    public static final BackgroundColor CYAN = new BackgroundColor("cyan");

    /** The background color white. */
    public static final BackgroundColor WHITE = new BackgroundColor("white");
}
